import { Geometry } from '../core/Geometry';
import { BufferGeometry } from '../core/BufferGeometry';

// Extras / Geometries /////////////////////////////////////////////////////////////////////
export class BoxBufferGeometry extends BufferGeometry {

	constructor(
		width?: number,
		height?: number,
		depth?: number,
		widthSegments?: number,
		heightSegments?: number,
		depthSegments?: number
	);

	parameters: {
		width: number;
		height: number;
		depth: number;
		widthSegments: number;
		heightSegments: number;
		depthSegments: number;
	};

}

/**
 * BoxGeometry is the quadrilateral primitive geometry class. It is typically used for creating a cube or irregular quadrilateral of the dimensions provided within the (optional) 'width', 'height', & 'depth' constructor arguments.
 */
export class BoxGeometry extends Geometry {

	/**
   * @param width — Width of the sides on the X axis.
   * @param height — Height of the sides on the Y axis.
   * @param depth — Depth of the sides on the Z axis.
   * @param widthSegments — Number of segmented faces along the width of the sides.
   * @param heightSegments — Number of segmented faces along the height of the sides.
   * @param depthSegments — Number of segmented faces along the depth of the sides.
   */
	constructor(
		width?: number,
		height?: number,
		depth?: number,
		widthSegments?: number,
		heightSegments?: number,
		depthSegments?: number
	);

	parameters: {
		width: number;
		height: number;
		depth: number;
		widthSegments: number;
		heightSegments: number;
		depthSegments: number;
	};

}
